<?php
  require "pano.inc";
//  $directory="test1";
//  $filename="test2.kml";
  echo "<pre>\n";
  if (!isset($_GET['path'])) {
    echo "Usage exif2kml.php?path=&lt;path_of_the_kml_file_to_be_created&gt;&ext=&lt;files_extension&gt;\n";
    echo " (the directory of the kml file should be the one with the images)\n";
    echo "</pre>\n";
    exit (1);
  }
  $path=$_GET['path'];
  $ext =$_GET['ext'];
  $directory=dirname($path);
  $filename=basename($path);
  echo "directory=$directory\n";
  echo "filename= $filename\n";


  chdir($directory);
  $files=glob("*.$ext");
  
  $numNodes=count($files);
  echo "numNodes= $numNodes\n";

//  exit(0);


  $world=array();
  for ($i=0;$i<$numNodes;$i++) {
    $world[$i]['href']=$files[$i];
    $exif_data = exif_read_data($files[$i]);
    $world[$i]['longitude']=(($exif_data['GPSLongitudeRef']=="W")?-1:1)*array2degrees($exif_data['GPSLongitude']);
    $world[$i]['latitude']= (($exif_data['GPSLatitudeRef'] =="S")?-1:1)*array2degrees($exif_data['GPSLatitude']);
    $world[$i]['altitude']= (($exif_data['GPSAltitudeRef'] =="1")?-1:1)*parseAlt($exif_data['GPSAltitude']);
    if (isset($exif_data['GPSImgDirection'])) {
      $world[$i]['heading']=  parseAlt($exif_data['GPSImgDirection']); // add correction  from magnetic?
      $world[$i]['tilt']= (($exif_data['GPSDestLatitudeRef'] =="S")?-1:1)*array2degrees($exif_data['GPSDestLatitude'])+90.0;
      if ($world[$i]['tilt']<0) $world[$i]['tilt']==0;
      else if ($world[$i]['tilt']>180) $world[$i]['tilt']=180;
      $world[$i]['roll']=(($exif_data['GPSDestLongitudeRef']=="W")?-1:1)*array2degrees($exif_data['GPSDestLongitude']);
    }
    else{
      $world[$i]['heading']=0;
      $world[$i]['tilt']=90;
      $world[$i]['roll']=0;
    }
  }
/*
  echo "<pre>\n";
  print_r($world);
  echo "</pre>\n";
  exit(0);
*/
//  $prefix='http://'.$_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF']).'/'.dirname($kmlFile).'/';

   $file=fopen ($filename,'w');
   fwrite($file,generateKML());
   fclose($file);

/*generateKML();
    header("Content-Type: text/xml\n");
    header("Content-Length: ".strlen($kml)."\n");
    header("Pragma: no-cache\n");
*/

   exit (0);

  function array2degrees($dms) {
    $round=1000000;
    $d=explode('/',$dms[0]);
    $m=explode('/',$dms[1]);
    $s=explode('/',$dms[2]);
    $rslt= $d[0]/$d[1]+($m[0]/$m[1])/60.0+($s[0]/$s[1])/3600.0;
    return round($round*$rslt)/$round;
  } 
  function parseAlt($alt) {
    $round=1000000;
    $a=explode('/',$alt);
    $rslt=  $a[0]/$a[1];
    return round($round*$rslt)/$round;
  } 

  function generateKML($index=-1) {
    global $world, $map, $numNodes;
    if ($index<0) $indices=range(0,$numNodes-1);
    else $indices=array_merge(array(0=>$index),$map[$index]);
    $kml=<<<HEADER
<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://earth.google.com/kml/2.2">
<Document>
HEADER;
    foreach ($indices as $i) {
      $kml.= "<PhotoOverlay>\n";
      $kml.= "  <Camera>\n";
      $kml.=sprintf("   <longitude>%s</longitude>\n",$world[$i]['longitude']);
      $kml.=sprintf("   <latitude>%s</latitude>\n",$world[$i]['latitude']);
      $kml.=sprintf("   <altitude>%s</altitude>\n",$world[$i]['altitude']);
      $kml.=sprintf("   <heading>%s</heading>\n",$world[$i]['heading']);
      $kml.=sprintf("   <tilt>%s</tilt>\n",$world[$i]['tilt']);
      $kml.=sprintf("   <roll>%s</roll>\n",$world[$i]['roll']);
      $kml.= "  </Camera>\n";
      $kml.= "  <Icon>\n";
      $kml.=sprintf("   <href>%s</href>\n",$world[$i]['href']);
      $kml.= "  </Icon>\n";
      $kml.= "</PhotoOverlay>\n";
    }
    $kml.=<<<TRAILER
</Document>
</kml>
TRAILER;
    return ($kml);   

  }




?>